%
function [y,hmod]=spa_arm(x,a,b,ires,nres,hmod,stip)
n=length(x);na=length(a);nb=length(b);n2p=2*nres;
if ires==1;
  wa(1:na)=a;wa(na+1:n2p)=zeros(1,n2p-na);
  wb(1:nb)=b;wb(nb+1:n2p)=zeros(1,n2p-nb);
end;
for i=1:n;       
  % Filtrado parte Autoregresiva
  y(i)=0;
  if na>1;
     nsa=na;
       if i<na;
          nsa=i;
       end;
       for j=1:nsa;
         y(i)=y(i)-a(j)*y(i-j+1);
       end;
  end;
  % filtrado parte moving average
  nsb=nb;
  if i<nb
    nsb=i;
  end;
  for j=1:nsb;
    y(i)=y(i)+b(j)*x(i-j+1);
  end;
end;
clear nsb nsa;
if ires==1;
  wa=fft(wa);wb=fft(wb);ii=find(abs(wa)<10E-6);
  wa(ii)=ones(1,length(ii))*10E-6;ir=find(abs(wb)<10E-6);
  wb(ir)=ones(1,length(ir))*10E-6;pow=ones(1,length(wb))*(x*x')/length(x);
  wa=wb./wa;n2p2=n2p/2;f=1:1:n2p2;hmod=20*log10(abs(wa(1:n2p2)));
  clear wb;figure(2);clf;
  xdib=[1 n2p2 min(hmod) max(hmod)];axis(xdib);f=0.5*f/max(f);
  plot(f,hmod,'k');grid;xlabel('Frequency');ylabel('dB.');
  title(['Frequency response of the model.-' stip]);
  ra=real(ifft(abs(wa(1:n2p2)),n/2));
end;
        
