%
%       SPA_BUR.M
%
function ra=spa_bur(xin,nq,nres,stip,hmod);
n=length(xin);f=xin(2:n)';b=xin(1:n-1)';a=[1];
erpo=xin*xin'/n;
for j=1:nq-1;
  k(j)=-2*f'*b/(f'*f+b'*b);cu=f+k(j)*b;du=b+k(j)*f;f=cu(2:n-j);b=du(1:n-j-1);
  au=[a;0];bu=[0;flipud(a)];a=au+k(j)*bu;erpo=erpo*(1-k(j)^2);
end;
disp('Lattice coefficients');disp(a);disp('Parcors');disp(k);
disp('Prediction error');disp(erpo);pi=3.14159265;
s=zeros(nres+1,nq);x=0:1:nres;
for j=1:nq;
  s(:,j)=exp(-sqrt(-1)*2*pi*(j-1)*x'/(2*nres));
end;
ra=ones(nres+1,1)*10*log10(erpo)-20*log10(abs(s*a));
xdib=[0 0.5 min([ra' hmod]) max([ra' hmod])];
plot (x/(2*nres),ra,'r');hold on;plot(x(1:nres)/(2*nres),hmod','b');axis(xdib);
xlabel('frequency');ylabel('S(w) in dB');
title(['MEM Burg.-' stip]);grid;pause(0.1);
