%
%
%       SPA_GEN.M
%
clear all;clf;clc;axis;
%       assigned variables
% sin 32/8
nsam=256;
nres=1024;
s_ac=zeros(1,nres);pi=3.14159265;jj=sqrt(-1);twopi=2*pi;
kk=menu('Elegir tipo de seal','ARMA','AR','MA','Sinusoides+ruido');
if kk==1;
  % Define denominator poles
   rop=[0.98 0.99];fip=[35 50];
   fipr=fip*pi/180;
   a1=[1 -2*rop(1)*cos(fipr(1)) rop(1)*rop(1)];a2=[1 -2*rop(2)*cos(fipr(2)) rop(2)*rop(2)];
   a=[1 a1(2)+a2(2) a1(3)+a2(3)+a1(2)*a2(2) a2(2)*a1(3)+a2(3)*a1(2) a1(3)*a2(3)];
   % Define numerator ceros
   ron=[0.99 0.98];fin=[70 130];
   finr=fin*pi/180;
   a1=[1 -2*ron(1)*cos(finr(1)) ron(1)*ron(1)];a2=[1 -2*ron(2)*cos(finr(2)) ron(2)*ron(2)];
   b=[1 a1(2)+a2(2) a1(3)+a2(3)+a1(2)*a2(2) a2(2)*a1(3)+a2(3)*a1(2) a1(3)*a2(3)];
   stip=['ARMA( ' num2str(length(b)) ' , ' num2str(length(a)) ') signal'];
   disp(['Numerator coefficients']);disp(b);
   disp(['Denominator coefficients']);disp(a);
   stip=['ARMA( ' num2str(length(b)) ' , ' num2str(length(a)) ') signal'];
%       input generation
  xin=randn(1,1000+nsam);[xinf1,hmod]=spa_arm(xin,a,b,1,nres,s_ac,stip);
  himp=resp_imp(nsam,a,b,stip);xinf=xinf1(1001:1000+nsam);mean1=sum(xinf)/length(xinf);
%  clear xin a b;
end;
if kk==2;
  a=[1 -2.7607 3.8106 -2.6535 0.9238];b=[1];
  stip=['AR( ' num2str(length(a)) ' ) signal'];
%       input generation
  xin=randn(1,1000+nsam);[xinf1,hmod]=spa_arm(xin,a,b,1,nres,s_ac,stip);
  himp=resp_imp(nsam,a,b,stip);xinf=xinf1(1001:1000+nsam);mean1=sum(xinf)/length(xinf);
  clear xin a b;
end;
if kk==3;
  a=[1];b=[1 -0.2 0.3 0.5 -0.1];
  stip=['MA( ' num2str(length(b)) ' ) signal'];
%       input generation
  xin=randn(1,1000+nsam);[xinf1,hmod]=spa_arm(xin,a,b,1,nres,s_ac,stip);
  himp=resp_imp(nsam,a,b,stip);xinf=xinf1(1001:1000+nsam);mean1=sum(xinf)/length(xinf);
  clear xin a b;
end;
if kk==4;
  xin=randn(1,nsam);snr=[10 10];fi=[0.1 0.2];
  alf=sqrt(2*10.^(snr/10));xinf=alf*sin(2*pi*fi'*(1:1:nsam))+xin;
  xinf=xinf-ones(1,length(xinf))*(sum(xinf)/length(xinf));
  stip=['Sinusoides en ruido'];himp=xinf;hmod=zeros(1,nres);pos=round(fi*nres*2);
  for i=1:length(fi);
    hmod(pos(i))=snr(i);
  end;
end;
figure(1);clf;xas=0:1:nsam-1;plot(xas,xinf,'b');
axis([0 nsam-1 min(xinf) max(xinf)]);xlabel('n.T');
ylabel('mvolts');title('Seal de entrada');grid;clear xas;
ku=menu('Elegir el orden para metodos parametricos','5',...
'8','12','15','20','Otro valor');
if ku==1;
  nq=5;
end;
if ku==2;
  nq=8;
end;
if ku==3;
  nq=12;
end;
if ku==4;
  nq=15;
end;
if ku==5;
  nq=20;
end;
if ku==6;
  nq=input('Entrar el orden....');
end;
%
eps=1;
while eps>0;
  ko=menu('elegir metodo','Peridograma','Correlacion','LP-Levinson',...
  'MLM-Capon','NMLM','LP-Lattice','ARMA Maxima Entropia','Durbin',...
  'ARMA-PISA','Ki-Ka','Music','Finalizar');
  disp(ko);figure(3);clf;
%
  if ko==1;clf;
    nres1=input('Resolucion deseada o puntos para segmentos...');
    nres2=nres;
    disp('Periodogram');
    xp=spa_wos(xinf,nres1,nres2,stip,hmod);
    clear xp;
  end;
%
  if ko==2;clf;
    nss=input('Numero de puntos....');
    suso=['Autocorrelation de ' num2str(nss) ' puntos'];disp(suso);
    for i=1:nss;
      r(i)=0;
      for j=1:nss-i+1;
        r(i)=r(i)+xinf(j)*xinf(j+i-1);
      end;r(i)=r(i)/nss;
    end;
    for i=1:nss;
      ra(i)=r(nss-i+1);
      if i<nss;
        ra(nss+i)=r(i+1);
      end;
    end;nra=length(ra);xd=-nss+1:1:nss-1;
    plot(xd,ra,'k');title('Autocorrelacion Estimada')
    xlabel('lags');ylabel('likelihood');
    grid;clear ra;
  end;
%
  if ko==3;clf;
    disp('Levinson');ra=spa_cor(xinf,nq);
    rb=spa_lev(ra,nq,nres,stip,hmod);
    clear rb;
  end;
%
  if ko==4;clf;
    disp('MLM');ra=spa_cor(xinf,nq);
    rc=spa_mlm(ra,nq,nres,stip,hmod);
    clear rc;
  end;
%
  if ko==5;clf;
    disp('NMLM');ra=spa_cor(xinf,nq);
    rd=spa_nml(ra,nq,nres,stip,hmod);
    clear rd;
  end;
%
  if ko==6;clf;
    disp('MEM lattice');ra=spa_cor(xinf,nq);
    re=spa_bur(xinf,nq,nres,stip,hmod);
    clear re;
  end;
  if ko==7;clf;
    disp(['MEM-ARMA']);
    np=input('Numerator order...... ');
    [sigma,outn,outd]=spa_arma_per(xinf,hmod,himp,stip,np,nq);disp('LAST Periodogram');
    sigma2=sigma^2;
    disp('Noise power');disp(sigma2);
    disp('Numerator coefficients');disp(outn);
    disp('Coefficients denorminator');disp(outd);
    % Compute spectral estimate with resolution nres
    aus=20*log10(abs((fft(outn,2*nres)./fft(outd,2*nres))));
    figure(3);clf;
    plot((1:1:nres),aus(1:nres),'r');grid;xlabel('frequency');
    ylabel('dB');title(['MEM-ARMA estimation (red) actual(blue)' stip] );
    hold on;plot((1:1:nres),hmod,'b');hold off;
  end;
  if ko==8;
    disp('Durbin Method')
    np=input('Numerator order...... ');
    [sigma,outn,outd]=spa_durbin(xinf,hmod,stip,nq,np);disp('ARMA-DURBIN');
    sigma2=sigma^2;
    disp('Noise power');disp(sigma2);
    disp('Numerator coefficients');disp(outn);
    disp('Coefficients denorminator');disp(outd);
    % Compute spectral estimate with resolution nres
    aus=20*log10(abs((fft(outn,2*nres)./fft(outd,2*nres))));
    figure(3);clf;
    plot((1:1:nres),aus(1:nres),'r');grid;xlabel('frequency');
    ylabel('dB');title(['ARMA-DURBIN  (red) actual(blue)' stip] );
    hold on;plot((1:1:nres),hmod,'b');hold off;
  end;
  if ko==9;
    disp('LAST');
    np=input('Numerator order...... ');
    [sigma,outn,outd,np,nq,leigen]=spa_arma_pismi(xinf,hmod,himp,stip,np,nq);
    sigma2=sigma^2;
    disp('Noise power');disp(sigma2);
    disp('Numerator coefficients');disp(outn);
    disp('Coefficients denorminator');disp(outd);
    % Compute spectral estimate with resolution nres
    aus=20*log10(abs((fft(outn,2*nres)./fft(outd,2*nres))));
    figure(3);clf;
    plot((1:1:nres),aus(1:nres),'r');grid;xlabel('frequency');
    ylabel('dB');title(['LAST (red) actual(blue)' stip] );
    hold on;plot((1:1:nres),hmod,'b');hold off;
  end;
  if ko==10;
    disp('Ki-Ka ARMA')
    np=input('Numerator order...... ');
    [sigma,outn,outd]=spa_arma_kika(xinf,hmod,himp,stip,np,nq);disp('KiKa Method');
    sigma2=sigma^2;
    disp('Noise power');disp(sigma2);
    disp('Numerator coefficients');disp(outn);
    disp('Coefficients denorminator');disp(outd);
    % Compute spectral estimate with resolution nres
    aus=20*log10(abs((fft(outn,2*nres)./fft(outd,2*nres))));
    figure(3);clf;
    plot((1:1:nres),aus(1:nres),'r');grid;xlabel('frequency');
    ylabel('dB');title(['ARMA-KiKa (red) actual(blue)' stip] );
    hold on;plot((1:1:nres),hmod,'b');hold off;
  end;
  if ko==11;
    disp('Music');ra=spa_cor(xinf,nq);
    rd=spa_music(ra,nq,nres,stip,hmod);
    clear rd;
  end;
  if ko==12;
    eps=-1;break;
  end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%