%
%       SPA_LEV.M
%
function ra=spa_lev(rd,nq,nres,stip,hmod);
oneq=[1;zeros(nq-1,1)];acoe=inv(rd)*oneq;
acoe=acoe/acoe(1);disp(acoe);errpre=oneq'*inv(rd)*oneq;
disp(errpre/rd(1,1));
%
pi=3.14159265;s=zeros(nres+1,nq);x=0:1:nres;
for j=1:nq;
  s(:,j)=exp(-sqrt(-1)*2*pi*(j-1)*x'/(2*nres));
end;
ra=abs(s*acoe);ra=ones(length(ra),1)*10*log10(errpre)-20*log10(ra);
xdib=[0 0.5 min([ra' hmod]) max([ra' hmod])];
plot (x(1:nres)/(2*nres),ra(1:nres),'r');
hold on;plot(x(1:nres)/(2*nres),hmod','b');axis(xdib);xlabel('frequency');
ylabel('S(w) in dB');title(['MEM Levinson.-' stip]);
grid;pause(0.5),
