%
%       SPA_MLM.M
%
function ra=spa_mlm(rb,nq,nres,stip,hmod);
%
pi=3.14159265;s=zeros(nq,nres+1);
x=0:1:nres;
for j=1:nq;
  s(j,:)=exp(-sqrt(-1)*2*pi*(j-1)*x/(2*nres));
end;
ra=10*log10(nq)-10*log10(real(diag(s'*inv(rb)*s)));
%
xdib=[0 0.5 min([ra' hmod]) max([ra' hmod])];
plot (x(1:nres)/(2*nres),ra(1:nres),'r');hold on;
plot(x(1:nres)/(2*nres),hmod','b');axis(xdib);xlabel('frequency');
ylabel('S(w) in dB');title(['MLM Capon.-' stip]);
grid;hold on;pause(0.1);
