%
%       SPA_WOS.M
%
function xp=spa_wos(x,nres,ncal,stip,hmod);
%
%       x seal real de entrada
%       nres resolucion (menor o igual que longitud de x(.)
%       ncal numero de puntos para la fft
%
n=length(x);ncal=2*ncal;
nco=min(nres,n);xf=zeros(1,ncal);i=1;ipro=0;
while i+nco-1<n;
  xo(1:nco)=x(i:nco+i-1);
  xo(nco+1:ncal)=zeros(1,ncal-nco);auso=fft(xo);
  xf=xf+auso.*conj(auso);i=i+(nco/2);ipro=ipro+1;
end;
xf=xf/(nres*ipro);xp=xf(1:ncal/2);xp=10*log10(xp);
clf;
x=0:1:(ncal/2)-1;x=0.5*x/max(x);xdib=[0 0.5 min([xp hmod]) max([xp hmod])];
plot(x,xp,'r');hold on;plot(x,hmod,'b');axis(xdib);xlabel('frequency');
ylabel('S(w) in dB');title(['Periodogram Method.-' stip]);
grid;pause(0.5);
