%--------------------------------------------------------------
%
%   Program spa_durbin_stat.m
%
%   This routine computes the Durbin algotihm
%
%   Miguel A. Lagunas                       June 2007
%
%-------------------------------------------------------------
function [sigma,outn,outd]=spa_durbin(xinf,hmod,stip,nq,np);
nsam=length(xinf);nres=length(hmod);nq1=nq-1;np1=np-1;
% select order for the AR model
nk=2*nq;
a=spa_lat_durbin(xinf,nk);
% Filtrado de la seal original
b=[1];
ew=spa_filt_durbin(xinf,b,a);
sigma=sqrt((ew*ew')/length(ew));
% Formacion matrices
auso=[];nlo=nk;
while nlo<nsam+1;
    buso=[xinf(nlo-1:-1:nlo-nq1) -ew(nlo-1:-1:nlo-np1)];
    auso=[auso;buso];nlo=nlo+1;
end;
cuso=xinf(nk:nsam)';duso=ew(nk:nsam)';
teta=-inv(auso'*auso)*auso'*(cuso);
outd=[1 teta(1:nq1)'];outn=[1 teta(nq1+1:length(teta))'];
%---------------------------------------------------------------