%
%       SPA_WOS_CEPS.M
%
function xp=spa_wos(x,nres,ncal,stip);
%
%       x seal real de entrada
%       nres resolucion (menor o igual que longitud de x(.)
%       ncal numero de puntos para la fft
%
n=length(x);ncal=2*ncal;
nco=min(nres,n);
xf=zeros(1,ncal);
i=1;
ipro=0;
while i+nco-1<n;
  xo(1:nco)=x(i:nco+i-1);
  xo(nco+1:ncal)=zeros(1,ncal-nco);
  auso=fft(xo);
  xf=xf+auso.*conj(auso);
  i=i+(nco/2);
  ipro=ipro+1;
end;
xf=xf/(nres*ipro);
xp=xf(1:ncal);
xpa=10*log10(xp);
%clear ncal n auso nco i xf ipro xo;
% Plot Periodogram WOSA
figure(13);clf;
x=0:1:(ncal/2)-1;x=x/ncal;
xdib=[0 0.5 min(xp) max(xp)];
axis(xdib);
plot(x,xpa(1:ncal/2),'r');
xlabel('frequency');
ylabel('S(w) in dB');
title([stip]);
grid;
